/**********************************************************************
** Copyright (C) 2000-2002 Trolltech AS.  All rights reserved.
**
** This file is part of the Qtopia Environment.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/
#ifndef BATTERY_H
#define BATTERY_H

#define POWER_STATUS	"Power Status"
#define	STD_SETTING1	"242"
#define	STD_SETTING2	"161"
#define	STD_SETTING3	"241"
#define USE_AC_ADAPTER	"AC"
#define	USE_BATTERY		"BATT"
#define	MODE_FORCE		"FORCE"

#include <qwidget.h>
#include <qguardedptr.h>
#include <qpopupmenu.h>
#include <qstring.h>

class PowerStatus;
class BatteryStatus;
class QTimer;

class BatteryMeter : public QWidget
{
    Q_OBJECT
public:
    BatteryMeter( QWidget *parent = 0 );
    ~BatteryMeter();

    QSize sizeHint() const;

protected:
    void timerEvent( QTimerEvent * );
    void paintEvent( QPaintEvent* );
    void showPowerStatus();
    void mousePressEvent( QMouseEvent * );
	void loadConfig();

protected slots:
    void chargeTimeout();
	void action(int);

protected:
    QGuardedPtr<BatteryStatus> batteryView;
    PowerStatus *ps;
    QSize bvsz;
    QTimer *chargeTimer;
    int percent;
    bool charging;
    bool updateBatteryViewGeometry();


	QPopupMenu* menu;
	unsigned int	cpuregister;
	QString  menuitem_title[10];
	unsigned int	menuitem_clock[10];
	unsigned int  ac_mode_clock;
	bool	ac_mode_force;
	unsigned int  battery_mode_clock;
	bool	battery_mode_force;

	int	menuitem_num;
	bool	SIG_sended;
};

#endif
